/*
  Application Name: "BUG" RTE IFRAME Editor.
  Author: Joe McCormack. Copyright 2005. All Rights Reserved.
  Firefox Support:
	Will work with Firefox 1.5+ on Windows XP+, but not Firefox 1.5+ on Windows 2000.
  Internet Explorer Support:
	Will work with IE 6+ on Windows XP+ and Windows 2000+.
*/

/* Do Not Use */
var caretPositionRTE = 0;				/* Caret (cursor) text position inside of RTE */
var hStartPositionRTE = 0;				/* Highlight start text position inside of RTE */
var hEndPositionRTE = 0;				/* Highlight end text position inside of RTE */
var hRange = 0;						/* Range of text highlighted */
var hData = "";						/* Textual data currently highlighted inside of RTE */
var ff_state = 0;					/* Firefox RTE status tracking */
var rteState = 0;					/* HTML/TEXT active state */
var caretHTMLPosition = 0;				/* Start position of caret in HTML code */
var caretHTMLPositionEnd = 0;				/* End position of caret highlight region in HTML code */
var lastActionRTE = "";					/* Last "do" action performed by user so it can be "undone" and "deleted" for FF Browsers */
var caretHTMLPositionRD = 0;				/* Caret start position for redo directive */
var caretHTMLPositionEndRD = 0;				/* Caret end position for redo directive */
var lastActionRTERD = "";				/* Last done action for redo directive */
var sysLastInvokeRTE = "";				/* Last directive passed to browser to handle */
var resolveExistRTE = 0;				/* Last known resolve status */
var hyperlinkTangent = 0;				/* Hyperlink branch currently being used */
var hyperlink_url = "";					/* Insert URL temp store data */
var hyperlink_txt = "";					/* Insert URL temp store data */
var hyperlink_sel = 0;					/* Insert URL temp store data */
var browserWorkCompleted = 0;				/* Tracker To Prevent Browser From Running Slow When User Rapid Clicks Respawning Already Spawned Events */
var FFloadWatch = 0;					/* Page Load Flag To Prevent FF From Prematurally Executing Function That Is Not Referenced */
var FFopenTagPos = -1;					/* Positional Flag For Original Open Tag Before FF Trashes It */
var FFcloseTagPos = -1;					/* Positional Flag For Original Close Tag Before FF Trashes It */
var FFopenTagName = "";					/* What The Opening Markup Was Before FF Trashes It */
var FFclsTagName = "";					/* What The Closing Markup Was Before FF Trashes It */
var listenEngine = 0;					/* Records What the RTE Does */
var listenData = "";					/* Data From A Listen Session */
var imageRTEData = "";					/* Temp Image Data For Insert */
var FFrangeWatcherResult = false;			/* Watch Range Logic Switching */
var FFrangeWatcherStatus = 0;				/* Status of Watch Range Logic Switching */
var bugStarted = 0;					/* Watch Select Range When No Content Follows */
var tableSelected = 0;					/* Table Region Selected */
var txtColorSelected = "";				/* Text Color Selected */
var passThru = "";					/* Pass Thru Data To Populate Editor With */
var passThruFlag = 0;					/* Loaded Status Before Pass Thru */
var passThruElapsed = 0;				/* Recall Interval To Test RTE Load State */
var ie_steps = 0;					/* Load process slow load tracking for IE */
var ie_breather = 1000;					/* Part of load process...pause between steps */
var img_fileid = "";					/* File Reference */
var chosen_filename = "";				/* Name of File */
var chosen_extension = "";				/* Extension(s) of File */

function passToRTE(content_stream) {
wakeRTE(content_stream);
}
function dataReturnRTE() {
var content = "";
if (rteState == 1) { content = pullFromRTE(); }
else { content = document.getElementById("txtSource").value; }
return content;
}
function saveRTE() {
dataFromRemoteRTE(pullFromRTE());
}
function wakeRTE(dataStream) {
/* Build Edit Window */
var rte_block = "<iframe id=\""+rteID+"\" name=\""+rteID+"\" style=\"direction:ltr;\" frameborder=\""+rteFB+"\" width=\""+rteWidth+"\" height=\""+rteHeight+"\" src=\"about:blank\"></iframe>";
document.getElementById(pageContentBlockRTE).innerHTML = rte_block;
/* Build Document */
if (navigator.userAgent.toLowerCase().indexOf("msie") != -1) { /*IE*/
	/* Too much for IE to handle.  Break into 3 timed steps. */
	if (dataStream.length == 0) { dataStream = "Content area that you can edit."; }
	passThru = removeExtrasRTE(dataStream);
	ie_steps = setTimeout("ieStep1()", ie_breather);
							     }
else { /*FF*/
      if (dataStream.length == 0) { dataStream = "Content area that you can edit."; }
      writeRTE(2, dataStream);
      document.getElementById(rteID).contentDocument.designMode = "on";
      attribRTE("nostyle");
	  
     }
rteState = 1;
}
function ieStep1() {
writeRTE(1, passThru);
clearTimeout(ie_steps); ie_steps = setTimeout("ieStep2()", ie_breather);
}
function ieStep2() {
frames[rteID].document.designMode = "on";
clearTimeout(ie_steps); ie_steps = setTimeout("ieStep3()", ie_breather);
}
function ieStep3() {
clearTimeout(ie_steps);
frames[rteID].document.onkeyup = function() { enter_monitor(); }
}
function generateRTEDoc(dataStream) {
var RTEsource = "";
RTEsource = "<html id=\"" + rteID + "\">\n";
RTEsource = RTEsource + "<head>\n";
RTEsource = RTEsource + "<link rel=\"stylesheet\" type=\"text/css\" media=\"all\" href=\"" + rteCSS + "\">\n";
RTEsource = RTEsource + "</head>\n";
RTEsource = RTEsource + "<body>\n";
RTEsource = RTEsource + dataStream + "\n";
RTEsource = RTEsource + "</body>\n";
RTEsource = RTEsource + "</html>";
return(RTEsource);
}
function writeRTE(target, dataStream) {
if (target == 1) {
	frames[rteID].document.open();
	frames[rteID].document.write(generateRTEDoc(dataStream));
	frames[rteID].document.close();
	frames[rteID].document.focus();
		 }
else {
      document.getElementById(rteID).contentWindow.document.open();
      document.getElementById(rteID).contentWindow.document.write(generateRTEDoc(dataStream));
      document.getElementById(rteID).contentWindow.document.close();
      document.getElementById(rteID).contentWindow.focus();
     }
}
function enter_monitor() {
/*
  Key Monitor For IE and Pressing 'ENTER'.  Circumvent IE Auto-Formatting.  Left Unmonitored Will Fubar RTE.
  Additional coding required to try to catch IE when a bulleted list is created.
  - After creation, IE will not pass 'ENTER' keypress events.
  - Even after exiting out of the list via double 'ENTER' or 'ENTER' + 'BACKSPACE' IE will not pass keypress events.
  - However, if a RTE directive is performed, such as bold, IE will then allow passing keypress events.
*/
var code;
if (navigator.userAgent.toLowerCase().indexOf("msie") != -1) { //IE
	code = window.frames[rteID].event.keyCode;
	if (code == 13) { caretModIERTE(); }
							     }
}
function caretModIERTE() {
/* Grab Caret Position After Enter Is Pressed */
/* Set Caret At Position Where Enter Was Pressed */
}

function spellcheckRTE() {
/* Spellcheck */
}
function filterDataStreamRTE(bypass, dataStream) {
var character = "", dataRebuild = "";
/* Filter Data For Occurrances Of < > */
if (bypass == 0) {
for (x = 0; x < dataStream.length; x++) {
	character = dataStream.charAt(x);
	if (character == "<") { character = "&lt;"; }
	if (character == ">") { character = "&gt;"; }
	dataRebuild = dataRebuild + character;
					}
		 }
else { dataRebuild = dataStream; }
return(dataRebuild);
}
function modeRTE(state) {
if (state == "on") {
	if (rteState == 0) {
		rteState = 1;
		if (navigator.userAgent.toLowerCase().indexOf("msie") != -1) { /*IE*/
				generateDesignRTE();
				document.getElementById(rteID).style.visibility = "visible";
				frames[rteID].document.body.focus();
									     }
		else { /*FF*/
		      if (source != 1) { generateDesignRTE(); }
		      document.getElementById(rteID).style.visibility = "visible";
		      document.getElementById(rteID).contentWindow.document.body.focus();
		     }
			   }
		   }
else {
      if (rteState == 1) {
		/* Warn User */
		msgCodeDesignRTE();
			 }
     }
}
function msgCodeDesignRTE() {
/* Code design mode */
}
function conCodeDesignRTE() {
rteState = 0;
if (navigator.userAgent.toLowerCase().indexOf("msie") != -1) { /*IE*/
		generateSourceRTE(pullFromRTE());
		document.getElementById(rteID).style.visibility = "hidden";
							     }
else { /*FF*/
      generateSourceRTE(pullFromRTE());
      document.getElementById(rteID).style.visibility = "hidden";
     }
cmdClsRTE();
}
function generateSourceRTE(dataStream) {
var rteOriginal = document.getElementById(pageContentBlockRTE).innerHTML;
if (!document.getElementById("txtSource")) {
	/* Create Text Editor */
	dataStream = filterDataStreamRTE(0, dataStream);
	document.getElementById(pageContentBlockRTE).innerHTML = rteOriginal + "<div id=\"txtSource_shell\" style=\"visibility:visible;position:relative;width:"+rteWidth+";height:"+rteHeight+";top:-"+rteHeight+";\"><textarea id=\"txtSource\" style=\"width:"+rteWidth+";height:"+rteHeight+";\" wrap=\"off\">"+dataStream+"</textarea></div>";
					   }
else {
      /* Update Existing Text Editor */
      dataStream = filterDataStreamRTE(1, dataStream);
      document.getElementById("txtSource").value = dataStream;
      document.getElementById("txtSource_shell").style.visibility = "visible";
     }
}
function generateDesignRTE() {
/* Dump Data Back Into Window */
if (document.getElementById("txtSource")) {
	if (navigator.userAgent.toLowerCase().indexOf("msie") != -1) { /*IE*/
		writeRTE(1, document.getElementById("txtSource").value);
								     }
	else { /*FF*/
	      writeRTE(2, document.getElementById("txtSource").value);
	     }
					  }
document.getElementById("txtSource_shell").style.visibility = "hidden";
}
function cleanRTE() {
/* Remove all markup, leaving all text */
}
function performUndoRTE() {
/* Undo what the user did in the RTE */
}
function performRedoRTE() {
/* Redo what the user undid in the RTE */
}
function pullFromRTE() {
var txtData = "";
if (navigator.userAgent.toLowerCase().indexOf("msie") != -1) { /*IE*/
	txtData = removeExtrasRTE(frames[rteID].document.body.innerHTML);
							     }
else { /*FF*/
      txtData = FFcolorWatchRTE(removeExtrasRTE(document.getElementById(rteID).contentWindow.document.body.innerHTML));
     }
return (txtData);
}
function pushToRTE(updated) {
if (navigator.userAgent.toLowerCase().indexOf("msie") != -1) { /*IE*/
	frames[rteID].document.body.innerHTML = updated;
	frames[rteID].document.body.focus();
							     }
else { /*FF*/
      document.getElementById(rteID).contentWindow.document.body.innerHTML = updated;
      document.getElementById(rteID).contentWindow.document.body.focus();
     }
}
function ieForce() {
if (navigator.userAgent.toLowerCase().indexOf("msie") != -1) { /*IE*/
	/*
	   Prevent IE From Ignoring the keypress listener that has been running.  This typically happens when
	   a line is added to the very end of the source code for the IFRAME (such as breaking out of a blockquote).
	*/
	var selection = frames[rteID].document.body.createTextRange();
	selection.collapse(true);
	selection.moveEnd('character', 0);
	selection.moveStart('character', 0);
	selection.select();
							     }
}
function attribRTE(markupType) {
if (browserWorkCompleted == 0) {
	var arg = markupType.toLowerCase();
	bugStarted = 0; txtColorSelected = "";
	if (navigator.userAgent.toLowerCase().indexOf("mozilla") != -1 && FFloadWatch == 0) { browserWorkCompleted = 0; }
	else { browserWorkCompleted = 1; }
	if (arg == "nostyle") { if (navigator.userAgent.toLowerCase().indexOf("mozilla") != -1) { /* Perform action */ } }
	if (arg == "hr") { /* Perform action */ }
	if (arg == "redo") { if (lastActionRTERD.length > 0) { /* Perform action */ } else { /* Perform action */ } }
	if (arg == "undo") { if (lastActionRTE.length > 0) { /* Perform action */ } else { /* Perform action */ } }
	if (arg == "subscript") { /* Perform action */ }
	if (arg == "superscript") { /* Perform action */ }
	if (arg == "italics") { /* Perform action */ }
	if (arg == "underline") { /* Perform action */ }
	/*
	  FOR THE FOLLOWING:
	  Handles inconsistent cross-browser formatting and/or arbitrary entire line auto-selections
	*/
	if (arg == "indent") { /* Perform action */ }
	if (arg == "bold") { /* Perform action */ }
	if (arg == "h1") { /* Perform action */ }
	if (arg == "h2") { /* Perform action */ }
	if (arg == "h3") { /* Perform action */ }
	if (arg == "h4") { /* Perform action */ }
	if (arg == "h5") { /* Perform action */ }
	if (arg == "h6") { /* Perform action */ }
	if (arg == "ol") { /* Perform action */ }
	if (arg == "ul") { /* Perform action */ }
	/*
	  FOR THE FOLLOWING:
	  Complete rewrite for customization and inconsistent cross-browser formatting
	*/
	if (arg == "hyperlink") { /* Perform action */ }
	if (arg == "image") { /* Perform action */ }
	if (arg == "table") { /* Perform action */ }
	if (arg == "lesstable") { /* Perform action */ }
	if (arg == "color") { /* Perform action */ }
	if (arg == "lesscolor") { /* Perform action */ }
	if (arg == "lessindent") { /* Perform action */ }
	if (arg == "bkindent") { /* Perform action */ }
	if (arg == "bkolul") { /* Perform action */ }
	if (arg == "delete") { /* Perform action */ }
			       } /* End browserWorkCompleted Flag */
}
function removeExtrasRTE(data) {
/* Perform Purge */
return data;
}
// SIG // Begin signature block
// SIG // MIIP6QYJKoZIhvcNAQcCoIIP2jCCD9YCAQExCzAJBgUr
// SIG // DgMCGgUAMGcGCisGAQQBgjcCAQSgWTBXMDIGCisGAQQB
// SIG // gjcCAR4wJAIBAQQQEODJBs441BGiowAQS9NQkAIBAAIB
// SIG // AAIBAAIBAAIBADAhMAkGBSsOAwIaBQAEFCChuLKLKF8Z
// SIG // ADAce5CWqSgLABxOoIIMCDCCA3owggJioAMCAQICEDgl
// SIG // 1/r4Ya+e9JDnJrXWWtUwDQYJKoZIhvcNAQEFBQAwUzEL
// SIG // MAkGA1UEBhMCVVMxFzAVBgNVBAoTDlZlcmlTaWduLCBJ
// .
// .
// .
// SIG // End signature block